/* awrite.c - send AAL5 PDU */

/* Written 1995-1998 by Werner Almesberger, EPFL-LRC/ICA */


#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <atm.h>
#include <linux/atmdev.h>
#define __KERNEL__
#include <asm/types.h>
struct sk_buff_head {
   struct sk_buff  * next;
   struct sk_buff  * prev;
   u32             qlen;     /* Must be same length as a pointer
                                           for using debugging */
};
#include "iphase.h"
#include "getopt.c"

void xdump( u_char*  cp, int  length, char*  prefix )
{
    int col, count;
    u_char prntBuf[120];
    u_char*  pBuf = prntBuf;
    count = 0;
    while(count < length){
        pBuf += sprintf( pBuf, "%s", prefix );
        for(col = 0;count + col < length && col < 16; col++){
            if (col != 0 && (col % 4) == 0)
                pBuf += sprintf( pBuf, " " );
            pBuf += sprintf( pBuf, "%02X ", cp[count + col] );
        }
        while(col++ < 16){      /* pad end of buffer with blanks */
            if ((col % 4) == 0)
                sprintf( pBuf, " " );
            pBuf += sprintf( pBuf, "   " );
        }
        pBuf += sprintf( pBuf, "  " );
        for(col = 0;count + col < length && col < 16; col++){
            if (isprint((int)cp[count + col]))
                pBuf += sprintf( pBuf, "%c", cp[count + col] );
            else
                pBuf += sprintf( pBuf, "." );
                }
        sprintf( pBuf, "\n" );
        printf(prntBuf);
        count += col;
        pBuf = prntBuf;
    }

}  /* close xdump(... */

int memdump(u32 maddr, int len, int action)
{
    struct sockaddr_atmpvc addr;
    IADEV dev;
    ia_regs_t ia_regs;
    int s;
    struct atmif_sioc req;
    IA_CMDBUF iacb;
    iacb.cmd = MEMDUMP;
    iacb.status = -1;
    iacb.len = len;
    iacb.maddr = maddr;
    req.number = 0;
    req.arg = (void *)&iacb;
 
    if ((s = socket(PF_ATMPVC,SOCK_DGRAM,0)) < 0) {
	perror("socket");
	return 1;
    }
    switch (action) {
      case 1: 				//MEMDUMP_DEV
      case 2:		 		//MEMDUMP_SEGREG
      case 3:				//MEMDUMP_REASSREG
        iacb.sub_cmd = action;
        iacb.buf = (void*)malloc(sizeof(IADEV));
        memset((char*)iacb.buf, 0, sizeof(IADEV));
        req.length = sizeof(IADEV)+sizeof(IA_CMDBUF);
        s = ioctl(s,  IA_CMD, &req);
        dev = *((IADEV *)iacb.buf);
        printf("status = %d\n", iacb.status);
        if (iacb.status < 0) {
           printf("ioctl failed\n");
           return 0;
        } 
        if (action == 1) {
          printf("Base    :  0x%8x  Real Base:  0x%8x\n",dev.base, dev.reg);
          printf("Dma Base:  0x%8x  Reg  Base:  0x%8x\n",dev.dma,dev.reg);   
          printf("Seg Ram :  0x%8x  Reass Ram:  0x%8x\n",dev.seg_ram,dev.reass_ram);
          printf("Seg Reg :  0x%8x  Reass Reg:  0x%8x\n",dev.seg_reg,dev.reass_reg);
        } 
        else {
          xdump((char*)iacb.buf, iacb.len, "HEX: ");
        }
        break;
      case 0:
        iacb.sub_cmd = 0;
        iacb.buf = (void*)malloc(len);
        memset((char*)iacb.buf, 0, len);
        req.length = len+sizeof(IA_CMDBUF);
        s = ioctl(s,  IA_CMD, &req);
        if (iacb.status < 0) {
           printf("ioctl failed\n");
           return 0;
        }
        xdump((char*)iacb.buf, iacb.len, "HEX: ");
        break;
      case 4:
	iacb.sub_cmd = action;
        iacb.buf = (void*)malloc(sizeof(ia_regs_t));
        memset((char*)iacb.buf, 0, sizeof(ia_regs_t));
        req.length = sizeof(ia_regs_t)+sizeof(IA_CMDBUF);
        s = ioctl(s,  IA_CMD, &req);
        ia_regs = *((ia_regs_t *)iacb.buf);
        printf("status = %d\n", iacb.status);
        if (iacb.status < 0) {
           printf("ioctl failed\n");
           return 0;
        }                                                
      case 5:
        iacb.sub_cmd = action;
        iacb.buf = (void*)malloc(4);
        memset((char*)iacb.buf, 0, 4);
        req.length = 4+sizeof(IA_CMDBUF);
        s = ioctl(s,  IA_CMD, &req);                                 
         printf("status = %d\n", iacb.status);
        if (iacb.status < 0) {
           printf("ioctl failed\n");
           return 0;
        }      
        printf("Register Value = 0x%x\n", *(int*)iacb.buf);
      default:

    }

#if 0
    if (argc != 3 && argc != 4) usage(argv[0]);
    if ((s = socket(PF_*ATMPVC,SOCK_DGRAM,0)) < 0) {
	perror("socket");
	return 1;
    }
    memset(&addr,0,sizeof(addr));
    if (text2atm(argv[1],(struct sockaddr *) &addr,sizeof(addr),T2A_PVC) < 0)
	usage(argv[0]);
    offset = argc == 3 ? 0 : atoi(argv[3]);
    memset(&qos,0,sizeof(qos));
    qos.aal = ATM_AAL5;
    qos.txtp.traffic_class = ATM_UBR;
    qos.txtp.max_sdu = strlen(argv[2])-offset;
    if (setsockopt(s,SOL_ATM,SO_ATMQOS,&qos,sizeof(qos)) < 0) {
	perror("setsockopt SO_ATMQOS");
	return 1;
    }
    if (connect(s,(struct sockaddr *) &addr,sizeof(addr)) < 0) {
	perror("connect");
	return 1;
    }
    size = write(s,argv[2]+offset,strlen(argv[2])-offset);
    printf("%d",size);
    if (size < 0) printf(" (%s)",strerror(errno));
    putchar('\n');
#endif
    return 0;
}


int main (int argc, char** argv) {
   int            arg_flag, edflag;
   char           *progname;
   u32            maddr = 0;
   unsigned  long long tmp;
   int            len, action, useMask = -1;
   extern char *optarg;            /* OS opt argument   */
   extern int   optind;            /* OS opt index      */
   extern int   opterr;            /* OS opt error      */
   //extern int   errno;             /* OS error number   */

   progname = argv[0];
   while ((arg_flag = getopt(argc, argv, "dm:l:a:")) != -1) {
     switch (arg_flag) {
       case 'm':
          tmp = strtoll(optarg, 0, 16);
          maddr = (u32)tmp;
          printf("maddr = 0x%x\n",maddr);
          useMask = 0;
          break;
       case 'l':
          len = atoi(optarg);
          printf("len = 0x%x\n", len);
          break;
       case 'a':
          useMask = 0x1;
          action = atoi(optarg);
          break;
     }
   }
   
   if (useMask == -1)
      return 0;
   if (useMask == 0) {
      if (len == 0) {
        printf("Error: not specify the memdump length\n");
        return 0;
      }
      memdump(maddr, len, 0);
   }
   else if (useMask & 0x1) {
      memdump(maddr, 0, action); 
   }   
   return 0;
}


